module Latex where


latex_pp_tab 0 = ""
latex_pp_tab n = "{\\phantom{XXXX}}"++(latex_pp_tab (n-1))


{-- 
 -- Função nl:
 --         concatena o termino de uma linha, com o standard WindowsNT
 --}
nl::String->String
nl s = s++"\r\n"


{--
    \tiny
    \scriptsize
    \footnotesize
    \small
    \normalsize
    \large
    \Large
    \LARGE
    \huge
    \Huge
--}
nl_block::(String,String)->String
nl_block(""  ,str) = "{\\normalsize"++" "++str++"}~\\\\\r\n"
nl_block(size,str) = "{\\"++size	++" "++str++"}~\\\\\r\n"

pp_latex_2e_landscape::String->String->String
pp_latex_2e_landscape sectionName body =  ("")
			++ nl("\\begin{landscape}")
--			++ nl("\\textbf{\\Large "++sectionName++"}~\\\\")
			++ body
			++ nl("\\end{landscape}")

pp_latex_2e_pair::(String,String)->(String,String)->String
pp_latex_2e_pair (c1,body1) (c2,body2) = nl("")
    ++ nl("\\begin{figure}[!htp]")
    ++ nl("\\centering")
    ++ nl("\\fbox{")
    ++ nl("\\begin{subfigure}[b]{0.4\\textwidth}")
    ++ nl("\\tiny")
    ++ body1
    ++ nl("\\caption{" ++ c1 ++ "}")
    ++ nl("\\end{subfigure}")

    ++ nl("\\begin{subfigure}[b]{0.4\\textwidth}")  
    ++ nl("\\tiny")
    ++ body2
    ++ nl("\\caption{" ++ c2 ++ "}")
    ++ nl("\\end{subfigure}")
    ++ nl("}")
    ++ nl("\\end{figure}")


pp_latex_2e_block::String->String->String
pp_latex_2e_block floatName body =  ("")
--            ++ nl("\\begin{figure}[!htp]")
            ++ nl("\\newpage")
			++ nl("\\textbf{\\Large "++floatName++"}~\\\\")
--			++ nl("\\noindent")
			++ nl(body)
--            ++ nl("\\end{figure}")
			++ nl("~\\\\")
--			++ nl("\\pagebreak")

{-- //LATEX --}

pp_latex_2e_document::[String]->String
pp_latex_2e_document l = ("")
            ++ nl("%& -output-directory=.web/program.pdf -aux-directory=C:/.web/lol")
            ++ nl("\\documentclass[6pt,letterpaper]{article}")
			++ pp_latex_2e_packages
			++ nl("\\begin{document}")
			++ (concat l)
			++ nl("\\end{document}")




pp_latex_2e_title::Int->String->String
pp_latex_2e_title 1 _	= nl("\\noindent")
			++ nl_block("small","Mestrado em Matemática e Computação")
			++ nl_block("small","Projecto de Dissertação - Ano lectivo de 2011/2013")
			++ nl_block("small","\\today")
--			++ nl("\\begin{center}")
			++ nl_block("large","\\phantom{.}\\hfill Bounded Model Checking para uma Linguagem Imperativa Simples\\hfill\\phantom{.}")
--			++ nl_block("large","Correcção do Método")
--			++ nl("\\end{center}~\\\\")
--			++ nl_block("","")
			++ nl_block("footnotesize","Realizado por:")
			++ nl_block("scriptsize","\\phantom{,}\\hspace{2cm} - José João Peixoto Pereira   - pg17312@alunos.uminho.pt")
--			++ nl_block("","")
			++ nl_block("footnotesize","Professores Orientadores:")
			++ nl_block("scriptsize","\\phantom{,}\\hspace{2cm} - Luís Filipe Ribeiro Pinto   - Departamento de Matemática")
			++ nl_block("scriptsize","\\phantom{,}\\hspace{2cm} - Jorge Sousa Pinto           - Departamento de Informática")
--			++ nl_block("","")
			++ nl_block("footnotesize","Em conformidade com o standard \\LaTeXe")
			++ nl_block("scriptsize","\\phantom{,}\\hspace{2cm} - \\url{http://latex.computersci.org/Reference/Reference}")
--			++ nl_block("","")
--			++ nl_block("","")

pp_latex_2e_title 0 pid	= ("")
			++ nl("\\title{Bounded Model Checking para uma Linguagem Imperativa Simples}")
			++ nl("\\date{\\today}")
			++ nl("\\author{José João Peixoto Pereira, pg17312@alunos.uminho.pt}")
			++ nl("\\maketitle")
			++ nl("\\vspace{.5cm}")
			++ nl("{\\Huge "++pid++"}")
--




pp_latex_2e_packages::String
pp_latex_2e_packages 	=  ("")
			++ nl("\\usepackage[utf8]{inputenc}")
			++ nl("\\usepackage[portuguese]{babel}")
			++ nl("\\usepackage{amsmath,amssymb}")
--			++ nl("\\usepackage[landscape]{geometry}")
			++ nl("\\usepackage[pdftex, colorlinks=true,")
			++ nl("    urlcolor=rltblue,")
			++ nl("    filecolor=rltgreen,")
			++ nl("    linkcolor=rltred,")
			++ nl("    pdftitle={Bounded Model Checking para uma Linguagem Imperativa Simples},")
			++ nl("    pdfauthor={pg17312 - José João Peixoto Pereira},")
			++ nl("    pdfsubject={...},")
			++ nl("    pdfkeywords={Semântica Operacional},")
			++ nl("    pagebackref,")
			++ nl("    pdfpagemode=None,")
			++ nl("    bookmarksopen=true]{hyperref}")
			++ nl("\\usepackage{color}")
			++ nl("\\definecolor{rltred}{rgb}{0.75,0,0}")
			++ nl("\\definecolor{rltgreen}{rgb}{0,0.5,0}")
			++ nl("\\definecolor{rltblue}{rgb}{0,0,0.75}")
			++ nl("\\definecolor{rltwhite}{rgb}{1,1,1}")
			++ nl("")
			++ nl("\\usepackage{setspace}")
			++ nl("\\usepackage{pdflscape}")
			++ nl("\\usepackage{fancyvrb}")
			++ nl("\\usepackage[cm]{fullpage}")
			++ nl("")
--			++ nl("\\usepackage{graphicx}")
            ++ nl("\\usepackage{color}")
			++ nl("\\usepackage{caption}")
			++ nl("\\usepackage{subcaption}")
			++ nl("")
--			++ nl("\\linespread{1.1}")