module Smt where
{-- 
 -- Função nl:
 --         concatena o termino de uma linha, com o standard WindowsNT
 --}
nl2::String->String
nl2 s = s++"\r\n"
    
{-- SMT-LIB v2.0--}


--
smt_lib_v2_comment::String->String
smt_lib_v2_comment comment = "; * "++comment++"\r\n"
--
pp_smt_lib_v2_headers::String
pp_smt_lib_v2_headers 	=  ""
			++ (smt_lib_v2_comment "Mestrado em Matemática e Computação")
			++ (smt_lib_v2_comment "Projecto de Dissertação - Ano lectivo de 2011/2013")
			++ (smt_lib_v2_comment "     - Bounded Model Checking para uma Linguagem Imperativa Simples")
			++ (smt_lib_v2_comment "Realizado por:")
			++ (smt_lib_v2_comment "     - José João Peixoto Pereira   - pg17312@alunos.uminho.pt")
			++ (smt_lib_v2_comment "Professores Orientadores:")
			++ (smt_lib_v2_comment "     - Luís Filipe Ribeiro Pinto   - Departamento de Matemática")
			++ (smt_lib_v2_comment "     - Jorge Sousa Pinto           - Departamento de Informática")
			++ (smt_lib_v2_comment "Em conformidade com o standard SMT-LIB v2.0")
			++ (smt_lib_v2_comment "     - \\url{goedel.cs.uiowa.edu/smtlib/papers/smt-lib-reference-v2.0-r10.03.30.pdf}")
{--
pp_smt_lib_v2_headers::String
pp_smt_lib_v2_headers 	=  ""
			++ (smt_lib_v2_comment "Mestrado em Matemática e Computação")
			++ (smt_lib_v2_comment "Projecto de Dissertação")
			++ (smt_lib_v2_comment "     - Ano lectivo de 2010/2011")
			++ (smt_lib_v2_comment "")
			++ (smt_lib_v2_comment "")
			++ (smt_lib_v2_comment "Bounded Model Checking para uma Linguagem Imperativa Simples")
			++ (smt_lib_v2_comment "     - Correcção e implementação de uma ferramenta BMC para software")
			++ (smt_lib_v2_comment "")
			++ (smt_lib_v2_comment "")
			++ (smt_lib_v2_comment "Realizado por:")
			++ (smt_lib_v2_comment "     - José João Peixoto Pereira   - pg17312@alunos.uminho.pt")
			++ (smt_lib_v2_comment "")
			++ (smt_lib_v2_comment "")
			++ (smt_lib_v2_comment "Professores Orientadores:")
			++ (smt_lib_v2_comment "     - Luís Filipe Ribeiro Pinto   - Departamento de Matemática")
			++ (smt_lib_v2_comment "     - Jorge Sousa Pinto           - Departamento de Informática")
			++ (smt_lib_v2_comment "")
			++ (smt_lib_v2_comment "")
			++ (smt_lib_v2_comment "Em conformidade com o standard SMT-LIB v2.0")
			++ (smt_lib_v2_comment "    \\url{goedel.cs.uiowa.edu/smtlib/papers/smt-lib-reference-v2.0-r10.03.30.pdf}")
			++ (smt_lib_v2_comment "")
			++ (smt_lib_v2_comment "")
--}
--
pp_smt_lib_v2_options::String
pp_smt_lib_v2_options	=  nl2("")
--            ++ smt_lib_v2_comment ""
			++ smt_lib_v2_comment "Options:"
--			++ smt_lib_v2_comment ""
			++ "(set-option :print-success true)\r\n"
{--			++ "(set-option :regular-output-channel \"stdout\")\r\n"
			++ "(set-option :diagnostic-output-channel \"stderr\")\r\n"
			++ "(set-option :expand-definitions false)\r\n"
			++ "(set-option :interactive-mode false)\r\n"
			++ "(set-option :produce-proofs true)\r\n"
			++ "(set-option :produce-unsat-cores false)\r\n"
--}{--			++ "(set-option :produce-models true)\r\n"
			++ "(set-option :produce-assignments false)\r\n"
			++ "(set-option :random-seed 0)\r\n"
			++ "(set-option :verbosity 0)\r\n"
--}
--
{--
foo::Int->String
foo 0		= ""
foo i	 	= " () "++(foo (i-1))
--}



{--
logical_conjunction [] = ""
logical_conjunction l = foldr (\x y -> (" (and "++x++y++") ")) single subSet
    where
        subSet = init l;
        single = last l
--}



{--
pp_smt_lib_v2_assertions::([Assertion],[Assertion])->String
pp_smt_lib_v2_assertions (p,c)	= ("")
                ++ smt_lib_v2_comment ""
				++ smt_lib_v2_comment "Assertions:"
				++ smt_lib_v2_comment ""
				++ laux2 --foldr(++)("")(unique laux)
	where
	    strP = map (smtShowAssertion) p;
	    strC = map (smtShowAssertion) c;
	    laux = "\n; * Codification of the Program\n"++(if((length strC)>0)then("(and ")else(""))++ (logical_conjunction strP)++"\n\n; * Codification of Conditions\n"++(if((length strC)>0)then("(not " ++ (logical_conjunction strC) ++ ")")else("")) ++ (if((length strC)>0)then("\n)")else(""));
	    laux2 = nl("(assert \n"++(laux)++"\n)")
--}

{--
foobar []      = error "empty Set to Set Conjuntion"
foobar [x]      = x
foobar (h:t)    = "(and "++h++(foobar t)++" ) "
--}


pp_smt_lib_v2_footers::String
pp_smt_lib_v2_footers	=  smt_lib_v2_comment ""
			++ smt_lib_v2_comment "Computation:"
			++ smt_lib_v2_comment "    - Check satisfiability"
--			++ smt_lib_v2_comment ""
			++ nl2("(check-sat)")
			++ nl2("(get-model) ; -- A formula is unsatisfiable if it does not have any model.")
--			++ "(get-proof)\r\n"
--			++ "(get-model)\r\n"
			++ nl2("(exit)")
			
			
			
			
			
			
			
