; * Mestrado em Matemática e Computação
; * Projecto de Dissertação - Ano lectivo de 2011/2013
; *      - Bounded Model Checking para uma Linguagem Imperativa Simples
; * Realizado por:
; *      - José João Peixoto Pereira   - pg17312@alunos.uminho.pt
; * Professores Orientadores:
; *      - Luís Filipe Ribeiro Pinto   - Departamento de Matemática
; *      - Jorge Sousa Pinto           - Departamento de Informática
; * Em conformidade com o standard SMT-LIB v2.0
; *      - \url{goedel.cs.uiowa.edu/smtlib/papers/smt-lib-reference-v2.0-r10.03.30.pdf}

; * Options:
(set-option :print-success true)

; * Declarations:
(declare-const x1 Int)
(declare-const y1 Int)
(declare-const x2 Int)
(declare-const y2 Int)
(declare-const x3 Int)
(declare-const y3 Int)

; * Assertions:
; *     set(C) -> set(P) === not_set(C) or set(P)
; *     is there a not (set(C)->set(P))? not(not_set(C) or set(P)) === set(C) and not_set(P)
(assert (and ; set(C), the Codification of the Program
     (and 
         (or  (not  true )  (=  x1 0 ))
     (and 
         (or  (not  true )  (=  y1  (+  x1 1 ) ))
     (and 
         (or  (not  (and  (and  true  (<  x1 0 )) (=  y1 0 )))  (=  x2  (+  x1 1 ) ))
     (and 
         (or  (not  (and  (and  true  (<  x1 0 )) (=  y1 0 )))  (=  y2 2 ))
     (and 
         (or  (not  (and  (and  true  (<  x1 0 )) (=  y1 0 )))  (=  x3  x2 ))
     (and 
         (or  (not  (and  (and  true  (<  x1 0 )) (=  y1 0 )))  (=  y3  y2 ))
     (and 
         (or  (not  (and  (and  true  (<  x1 0 )) (not  (=  y1 0 )) ))  (=  y2  (-  y1 1 ) ))
     (and 
         (or  (not  (and  (and  true  (<  x1 0 )) (not  (=  y1 0 )) ))  (=  x3  x1 ))
     (and 
         (or  (not  (and  (and  true  (<  x1 0 )) (not  (=  y1 0 )) ))  (=  y3  y2 ))
     (and 
         (or  (not  (and  (and  (and  true  (<  x1 0 )) (<  x1 0 )) (=  y1 0 )))  (=  x2  (+  x1 1 ) ))
     (and 
         (or  (not  (and  (and  (and  true  (<  x1 0 )) (<  x1 0 )) (=  y1 0 )))  (=  y2 2 ))
     (and 
         (or  (not  (and  (and  (and  true  (<  x1 0 )) (<  x1 0 )) (=  y1 0 )))  (=  x3  x2 ))
     (and 
         (or  (not  (and  (and  (and  true  (<  x1 0 )) (<  x1 0 )) (=  y1 0 )))  (=  y3  y2 ))
     (and 
         (or  (not  (and  (and  (and  true  (<  x1 0 )) (<  x1 0 )) (not  (=  y1 0 )) ))  (=  y2  (-  y1 1 ) ))
     (and 
         (or  (not  (and  (and  (and  true  (<  x1 0 )) (<  x1 0 )) (not  (=  y1 0 )) ))  (=  x3  x1 ))
     (and 
         (or  (not  (and  (and  (and  true  (<  x1 0 )) (<  x1 0 )) (not  (=  y1 0 )) ))  (=  y3  y2 ))
     (and 
         (or  (not  (and  (and  true  (<  x1 0 )) (<  x1 0 )))  (=  x2  x1 ))
     (and 
         (or  (not  (and  (and  true  (<  x1 0 )) (<  x1 0 )))  (=  y2  y1 ))
     (and 
         (or  (not  (and  (and  true  (<  x1 0 )) (not  (<  x1 0 )) ))  (=  x2  x1 ))
     (and 
         (or  (not  (and  (and  true  (<  x1 0 )) (not  (<  x1 0 )) ))  (=  y2  y1 ))
     (and 
         (or  (not  (and  true  (<  x1 0 )))  (=  x2  x1 ))
     (and 
         (or  (not  (and  true  (<  x1 0 )))  (=  y2  y1 ))
     (and 
         (or  (not  (and  true  (not  (<  x1 0 )) ))  (=  x2  x1 ))
     (and 
         (or  (not  (and  true  (not  (<  x1 0 )) ))  (=  y2  y1 ))
     (and 
         (or  (not  (and  true  (=  y1  x1 )))  (=  x2  x1 ))
     (and 
         (or  (not  (and  true  (=  y1  x1 )))  (=  y2  y1 ))
     (and 
         (or  (not  (and  true  (not  (=  y1  x1 )) ))  (=  x2  x1 ))
         (or  (not  (and  true  (not  (=  y1  x1 )) ))  (=  y2  y1 ))
)))))))))))))))))))))))))))
 (not ; not_set(P) the Codification of the Conditions
     (and 
         (or  (not  true )  (<  x1  y1 ))
     (and 
         (or  (not  (and  (and  true  (<  x1 0 )) (<  x1 0 )))  false )
     (and 
         (or  (not  (and  true  (=  y1  x1 )))  (=  x1  y1 ))
         (or  (not  (and  true  (not  (=  y1  x1 )) ))  (not  (=  x1  y1 )) )
)))
)))
; * 
; * Computation:
; *     - Check satisfiability
(check-sat)
(get-model) ; -- A formula is unsatisfiable if it does not have any model.
(exit)
