
--%
--%
--%
--%
--%
--%

{-- my Package: funções auxiliares de formatação de strings--}	
{-- 
 -- Função unique:
 --         remove elementos repetidos
 --}
unique::(Eq a)=>[a]->[a]
unique l = aux [] l
	where	aux ref [] = ref ;
		    aux ref (h:t) 	|(elem h t) = aux ref t
				            | otherwise = aux (h:ref) t
{-- 
 -- Função nl:
 --         concatena o termino de uma linha, com o standard WindowsnT
 --}
nl::String->String
nl s = s++"\r\n"
nl_block::(String,String)->String
nl_block(""  ,str) = "{\\normalsize"	++" "++str++"}\\\\\r\n"
nl_block(size,str) = "{\\"++size	++" "++str++"}\\\\\r\n"



{-- extenção aos comandos do While --}
-- data BMC_Command	= BMC_Skip
-- 		        	| BMC_Assign 	String		ExpInt
-- 		        	| BMC_Composition 			BMC_Command BMC_Command
-- 		        	| BMC_If 		ExpBool	    BMC_Command BMC_Command
-- -- No while
-- 		        	| BMC_Call		String
-- 					| BMC_Assert	ExpBool

-- instance Show BMC_Command where
-- 	show(BMC_Skip					) = "skip";
-- 	show(BMC_Assign 	str	e		) = ( str)++" = "++(show e);
-- 	show(BMC_Composition	c1 c2	) = (show c1)++" ; \r\n"++(show c2);
-- --	show(BMC_If 		b	c1 c2	) = "if("++(show b)++"){\r\n"++(pp_hs_command (n+1) c1)++"\r\n}else{\r\n"++(pp_hs_command (n+1) c2)++"\r\n}";
-- 	show(BMC_Call		str			) = "call "++( str)
-- 	show(BMC_Assert		b			) = "assert "++(show b)
		
{-- Templates --}
e1 = (Assign 0 "x" (Variable 0 "x"))
e2 = (Assign 0 "x" (Variable 0 "3"))
e3 = (Assign 0 "x" (I_Plus (Variable 0 "x") (Variable 0 "y"))) -- x = x + y

e4 = (Assign 0 "y" (I_Plus (Variable 0 "x") (Variable 0 "y")))

e5 = (Composition e3 e4)
e6 = (Composition e4 e3)
e7 = (Composition e4 e4)

e10 = read "(Composition(Assert (B_Top))(Composition(Skip)(Composition(Assign(x)(Number 3))(Composition(Assign(x)(I_Plus(Number 3)(I_Plus(Variable y)(Variable z))))(Composition(Assign(r)(I_Plus(Array a (I_Plus(Number 3)(I_Plus(Number 20)(Variable yeffi))))(Variable h)))(Composition(If(B_And(B_Lt(Number 3)(Number 4))(B_Gt(Variable x)(Number 6)))(Assign(yeffi)(Variable yeffi))(Skip))(Composition(While(B_Gt(Variable x)(Number 6))(A_Atom(B_Gt(Variable i)(Number 6)))(Skip))(Assert (B_Gt(Variable x)(Number 9))))))))))"::Command
e11 = read "(Composition(Skip)(Assert (B_Gt(Variable x)(Number 9))))"::Command

functionExpInt::ExpInt->String
functionExpInt(Number   i)	            = ""
functionExpInt(Variable i s)	        = ""
functionExpInt(Array	  i s e)        = ""
functionExpInt(Function s l)            = ""
functionExpInt(Neg  e  ) 		        = ""
functionExpInt(I_Plus  e1 e2)           = ""
functionExpInt(I_Minus e1 e2)           = ""
functionExpInt(I_Times e1 e2)           = ""
functionExpInt(I_Div   e1 e2)           = ""
functionExpInt(I_Mod   e1 e2)           = ""
functionExpBool::ExpBool->String
functionExpBool(B_Top)	                = ""
functionExpBool(B_Bottom)	            = ""
functionExpBool(B_Not b)	            = ""
functionExpBool(B_And b1 b2)            = ""
functionExpBool(B_Or  b1 b2)            = ""
functionExpBool(B_Eq  e1 e2)            = ""
functionExpBool(B_Lt  e1 e2)            = ""
functionExpBool(B_Le  e1 e2)            = ""
functionExpBool(B_Gt  e1 e2)            = ""
functionExpBool(B_Ge  e1 e2)            = ""

functionAssertion::Assertion->String
functionAssertion(A_Atom	b)          = ""
functionAssertion(A_Not	phi)            = ""
functionAssertion(A_And	phi psi)        = ""
functionAssertion(A_Or	phi psi)        = ""
functionAssertion(A_Then	phi psi)    = ""
functionAssertion(A_Iff	phi psi)	    = ""
functionAssertion(A_Forall	s phi)		= ""
functionAssertion(A_Exists	s phi)		= ""

functionCommand::Command->String
functionCommand(Skip)			        = ""
functionCommand(Assign	i v e)		    = ""
functionCommand(Composition 	c1 c2)	= ""
functionCommand(If 	b	    c1 c2)	    = ""
functionCommand(While 	b i 	c)	    = ""
--functionCommand(Proc 	v c)            = ""
functionCommand(Call 	v)		        = ""
functionCommand(Assert	b)		        = ""
		
		
		
{-- Modelo do programa --}
data BMC_Model 	= BMC_Cmp 			BMC_Model 	BMC_Model
				| BMC_IF 			ExpBool	  	Command					-- o BMC_if leva assert e não  ExpBool

instance Show BMC_Model where
	show(BMC_Cmp m1 m2) = show(m1)++show(m2)
	show(BMC_IF  e  c ) = "if("++(show e)++")["++(show c)++"];\n"




--
-- This unwinding mechanism takes into account the fact that while loops might also have while loops inside
-- their bodies also.
--
unwind2::Int->Command->Command
unwind2 n w@(Skip)				= (Skip)
unwind2 n w@(Assign i v e)		= (Assign i v e)
unwind2 n w@(Assert	e)			= (Assert e)
unwind2 n w@(Composition c1 c2)	= (Composition (unwind2 n c1) (unwind2 n c2))
unwind2 n w@(If b c1 c2)		= (If b (unwind2 n c1) (unwind2 n c2))
unwind2 n w@(Call s)			= (Call s)
unwind2 n w@(While e c) 		= (aux (n,n) w)
	where
 		aux (n,0) w@(While e c) 	= (Assert (B_Not e));
		aux (n,m) w@(While e c) 	= (If e (Composition (unwind2 n c) (aux (n,m-1) w)) Skip)




dynamicSAF::Command->Command
dynamicSAF c = cmd
    where (tb,cmd) = safCommand [] c
    

{-- Get Variables --}
get_variables_ExpInt::ExpInt->[(String,Int)]
get_variables_ExpInt(Number   i)        = []
get_variables_ExpInt(Variable i s)	    = [(s,i)]
get_variables_ExpInt(Array	  i s e)    = [(s,i)] ++ (get_variables_ExpInt e)
get_variables_ExpInt(Function s l)      = [(s,0)] ++ (foldr (++) ([]) args)
    where args = (map (\y -> (get_variables_ExpInt y)) l)
get_variables_ExpInt(Neg  e)            = (get_variables_ExpInt  e)
get_variables_ExpInt(I_Plus  e1 e2)     = (get_variables_ExpInt  e1) ++ (get_variables_ExpInt  e2)
get_variables_ExpInt(I_Minus e1 e2)     = (get_variables_ExpInt  e1) ++ (get_variables_ExpInt  e2)
get_variables_ExpInt(I_Times e1 e2)     = (get_variables_ExpInt  e1) ++ (get_variables_ExpInt  e2)
get_variables_ExpInt(I_Div   e1 e2)     = (get_variables_ExpInt  e1) ++ (get_variables_ExpInt  e2)
get_variables_ExpInt(I_Mod   e1 e2)     = (get_variables_ExpInt  e1) ++ (get_variables_ExpInt  e2)
get_variables_ExpBool::ExpBool->[(String,Int)]
get_variables_ExpBool(B_Top)	        = []
get_variables_ExpBool(B_Bottom)	        = []
get_variables_ExpBool(B_Not b)	        = (get_variables_ExpBool b)
get_variables_ExpBool(B_And b1 b2)      = (get_variables_ExpBool b1) ++ (get_variables_ExpBool b2)
get_variables_ExpBool(B_Or  b1 b2)      = (get_variables_ExpBool b1) ++ (get_variables_ExpBool b2)
get_variables_ExpBool(B_Eq  e1 e2)      = (get_variables_ExpInt  e1) ++ (get_variables_ExpInt  e2)
get_variables_ExpBool(B_Lt  e1 e2)      = (get_variables_ExpInt  e1) ++ (get_variables_ExpInt  e2)
get_variables_ExpBool(B_Le  e1 e2)      = (get_variables_ExpInt  e1) ++ (get_variables_ExpInt  e2)
get_variables_ExpBool(B_Gt  e1 e2)      = (get_variables_ExpInt  e1) ++ (get_variables_ExpInt  e2)
get_variables_ExpBool(B_Ge  e1 e2)      = (get_variables_ExpInt  e1) ++ (get_variables_ExpInt  e2)
{--
get_variables_Assertion::Assertion->String
get_variables_Assertion(A_Atom	b)          = ""
get_variables_Assertion(A_Not	phi)            = ""
get_variables_Assertion(A_And	phi psi)        = ""
get_variables_Assertion(A_Or	phi psi)        = ""
get_variables_Assertion(A_Then	phi psi)    = ""
get_variables_Assertion(A_Iff	phi psi)	    = ""
get_variables_Assertion(A_Forall	s phi)		= ""
get_variables_Assertion(A_Exists	s phi)		= ""

functionCommand::Command->String
functionCommand(Skip)			        = ""
functionCommand(Assign	i v e)		    = ""
functionCommand(Composition 	c1 c2)	= ""
functionCommand(If 	b	    c1 c2)	    = ""
functionCommand(While 	b i 	c)	    = ""
--functionCommand(Proc 	v c)            = ""
functionCommand(Call 	v)		        = ""
functionCommand(Assert	b)		        = ""
--}


{-- Dar o número de acordo com uma tabela --}
safExpInt::[(String,Int)]->ExpInt->([(String,Int)],ExpInt)
safExpInt li w@(Number   i)         = (li,(Number   i))
safExpInt li w@(Variable i s)	    = (li,(Variable (get s li) s ))
safExpInt li w@(Array    i s e)     = (li,(Array	(get s li) s (expr) ))
    where
        (tbl,expr) = (safExpInt li e)
safExpInt li w@(Function s l)       = (li,(Function s exprs))
    where
        args = (map (\y -> safExpInt li y) l);
        (tbls,exprs) = unzip args
safExpInt li w@(Neg  e) 		    = (li,(Neg (expr) ))
    where
        (tbl,expr) = (safExpInt li e)
safExpInt li w@(I_Plus  e1 e2)      = (li,(I_Plus (expr1) (expr2) ))
    where
        (tbl1,expr1) = (safExpInt li e1);
        (tbl2,expr2) = (safExpInt li e2)
safExpInt li w@(I_Minus e1 e2)      = (li,(I_Minus (expr1) (expr2) ))
    where
        (tbl1,expr1) = (safExpInt li e1);
        (tbl2,expr2) = (safExpInt li e2)
safExpInt li w@(I_Times e1 e2)      = (li,(I_Times (expr1) (expr2) ))
    where
        (tbl1,expr1) = (safExpInt li e1);
        (tbl2,expr2) = (safExpInt li e2)
safExpInt li w@(I_Div   e1 e2)      = (li,(I_Div (expr1) (expr2) ))
    where
        (tbl1,expr1) = (safExpInt li e1);
        (tbl2,expr2) = (safExpInt li e2)
safExpInt li w@(I_Mod   e1 e2)      = (li,(I_Mod (expr1) (expr2) ))
    where
        (tbl1,expr1) = (safExpInt li e1);
        (tbl2,expr2) = (safExpInt li e2)

safExpBool::[(String,Int)]->ExpBool->([(String,Int)],ExpBool)
safExpBool li w@(B_Top)	            = (li,(B_Top))
safExpBool li w@(B_Bottom)	        = (li,(B_Bottom))
safExpBool li w@(B_Not b)	        = (li,(B_Not (boolean) ))
    where
        (tbl,boolean) = (safExpBool li b)
safExpBool li w@(B_And b1 b2)       = (li,(B_And (boolean1)  (boolean2) ))
    where
        (tbl1,boolean1) = (safExpBool li b1);
        (tbl2,boolean2) = (safExpBool li b2)
safExpBool li w@(B_Or  b1 b2)       = (li,(B_Or  (boolean1)  (boolean2) ))
    where
        (tbl1,boolean1) = (safExpBool li b1);
        (tbl2,boolean2) = (safExpBool li b2)
safExpBool li w@(B_Eq  e1 e2)       = (li,(B_Eq (expr1) (expr2) ))
    where
        (tbl1,expr1) = (safExpInt li e1);
        (tbl2,expr2) = (safExpInt li e2)
safExpBool li w@(B_Lt  e1 e2)       = (li,(B_Lt (expr1) (expr2) ))
    where
        (tbl1,expr1) = (safExpInt li e1);
        (tbl2,expr2) = (safExpInt li e2)
safExpBool li w@(B_Le  e1 e2)       = (li,(B_Le (expr1) (expr2) ))
    where
        (tbl1,expr1) = (safExpInt li e1);
        (tbl2,expr2) = (safExpInt li e2)
safExpBool li w@(B_Gt  e1 e2)       = (li,(B_Gt (expr1) (expr2) ))
    where
        (tbl1,expr1) = (safExpInt li e1);
        (tbl2,expr2) = (safExpInt li e2)
safExpBool li w@(B_Ge  e1 e2)       = (li,(B_Ge (expr1) (expr2) ))
    where
        (tbl1,expr1) = (safExpInt li e1);
        (tbl2,expr2) = (safExpInt li e2)
{--
safAssertion::[(String,Int)]->Assertion->([(String,Int)],Assertion)
safAssertion li w@(A_Atom	b)      = (li,)
safAssertion li w@(A_Not	phi)    = (li,)
safAssertion li w@(A_And	phi psi)= (li,)
safAssertion li w@(A_Or	    phi psi)= (li,)
safAssertion li w@(A_Then	phi psi)= (li,)
safAssertion li w@(A_Iff	phi psi)= (li,)
safAssertion li w@(A_Forall	s phi)	= (li,)
safAssertion li w@(A_Exists	s phi)	= (li,)
--}
safCommand::[(String,Int)]->Command->([(String,Int)],Command)
safCommand li w@(Skip)				= (li,  (Skip))
safCommand li w@(Call s)			= (li,	(Call s))
safCommand li w@(Assert	b)	    	= (lo,	(Assert (boolean) ))
	where
	        l = get_variables_ExpBool(b);
	        lo = learn l li;
	        (tbl,boolean) = (safExpBool lo b)
safCommand li w@(Assign i v e)		= (lo,  (Assign (get v lo) v (expr) ))
	where
	    l_lrn   = get_variables_ExpInt(e);
	    l_now   = learn l_lrn li;
	    l_err   = learn [(v,i)] l_now;      -- corrects the following error!
		lo      = update(l_err,v);          -- must give an error if we are assigning an Unknown variable?!?
		(tbl,expr) = (safExpInt l_now e)
safCommand li w@(Composition c1 c2)	= (lo,	(Composition cmd1 cmd2))
	where
		(l2,cmd1) = (safCommand li c1);
		(lo,cmd2) = (safCommand l2 c2)
safCommand li w@(If b c1 c2)		=  (lo, (If (boolean) (foldl (\a b -> (Composition a b)) cmd1 lt) (foldl (\a b -> (Composition a b)) cmd2 lf)  ))
	where
	    (tb,boolean) = (safExpBool li b);
		(l1,cmd1)    = (safCommand li c1);
		(l2,cmd2)    = (safCommand li c2);						{-- está aqui o problema do DsAF :S--}
		(handle,lo)  = coldFusionX l1 l2 [];
		(lt,lf)      = unzip handle
{-- We dons use whiles do we? >.<  --}
--safCommand li w@(While b i c) 		= error "safCommand while";
--    (lo,  (While (name_ExpBool(li,b)) i cmd))
--	where (lo,cmd) = (saf li c)


		
{-- coldFusionX --}
--coldFusionX tblT tblF tbl = (Command,Command)
--{pre: #left > #}
-- returns ([(lista_cmd_True,lista_cmd_False)],state_tbl)
-- new_tbl , vão sendo retirados elementos
coldFusionX  ([]) ([])  bag = ([],bag)
coldFusionX   tbl ([])  bag = ([],bag ++ tbl)
coldFusionX  ([]) tbl   bag = ([],bag ++ tbl)
coldFusionX (h:t) tbl   bag = let (new_tbl,something) = (fusionX h tbl)
    in case something of
        Nothing     -> (coldFusionX t new_tbl (h:bag))
        Just(s,l,r) -> if (l>r) then ( (left_cmd:xx_left) ,yy_left )
                                                    else if (l<r)   then ((right_cmd:xx_right),yy_right)
                                                                    else (coldFusionX t new_tbl (h:bag)) -- if (l==r)
            where
                left_cmd  = ((Assign (l+1) s (Variable l s)),(Assign (l+1) s (Variable r s)));
                right_cmd = ((Assign (r+1) s (Variable l s)),(Assign (r+1) s (Variable r s)));
                (xx_left,yy_left)   = (coldFusionX t new_tbl ((s,l+1):bag));
                (xx_right,yy_right) = (coldFusionX t new_tbl ((s,r+1):bag));


fusionX   e       []    = ([],Nothing)
fusionX (a,b) ((x,y):t) |a==x = (      xx,(Just(a,b,y)))
                        |True = ((x,y):xx,yy         )
    where (xx,yy)= (fusionX (a,b) t)
	
{-- Auxiliary --}{--    lixo
functionCommand::Command->String
get_assign_Command(Skip)			    = []
get_assign_Command(Assign	i v e)		= [(v,i)]
get_assign_Command(Composition 	c1 c2)	= get_assign_Command(c1)++get_assign_Command(c2)
get_assign_Command(If 	    b   c1 c2)	= get_assign_Command(c1)++get_assign_Command(c2)
get_assign_Command(While 	b i 	c)	= get_assign_Command(c)
get_assign_Command(Call 	v)		    = []
get_assign_Command(Assert	b)		    = []
		--}
{-- Auxiliary Learn --}
learn::[(String,Int)]->[(String,Int)]->[(String,Int)]
learn []    l   = l
learn (h:t) l   = learn t (aux h l)
    where
        aux (a,b) []        = [(a,b)];
        aux (a,b) ((x,y):t) = if(a==x)then (x,y):t else (x,y):(aux (a,b) t)

update([],v) = error "update"
update(((x,y):t),v) | v==x = (x,y+1):t
 					| True = (x,y):(update(t,v))

get e [] = error "update"
get e ((x,y):t) | e==x = y
 				| True = get e t
 				
{--






--}
{-- vai dar uma lista de  --}
{--
-- mega ListaMax ListaMeu
mega [] _ = Skip
mega ((a,b):t) lMeu = case (aux a lMeu) of
						Nothing	-> (mega t lMeu)
					 	Just m	-> Composition (Assign b a (Variable m a)) (mega t lMeu)
	where
		aux x []		= Nothing;
		aux x ((a,b):t) = if(a==x) then (Just b) else (aux x t)

--}
{-- esta é a lista dos maximos comuns --}
{--
wootMAX [] = []
wootMAX ((a,b):t) = case (aux a t) of
						Nothing	-> (a,b):(wootMAX (clean a t))
					 	Just b2	-> (a,(max b b2)):(wootMAX (clean a t))
	where
		aux x []		= Nothing;
		aux x ((a,b):t) = if(a==x) then (Just b) else (aux x t);
		clean x [] = [];
		clean x ((a,b):t) = if(a==x) then (clean x t) else ((a,b):(clean x t))
		


name([],v) = error("[ERROR]:item["++v++"] not declared")
name(((x,y):t),v) 	| v==x = y
 					| True = (name(t,v))


name_ExpInt(li,(Number   i)     ) = (Number   i)
name_ExpInt(li,(Variable i s)   ) = (Variable (name(li,s)) s )
name_ExpInt(li,(Array    i s e)	) = (Array    (name(li,s)) s (name_ExpInt(li,e)))
name_ExpInt(li,(Function s args)) = (Function s (map (\arg -> (name_ExpInt(li,arg))) args))
name_ExpInt(li,(Neg  e) 	    ) = (Neg      (name_ExpInt(li,e)))
name_ExpInt(li,(I_Plus  e1 e2)  ) = (I_Plus   (name_ExpInt(li,e1)) (name_ExpInt(li,e2)))
name_ExpInt(li,(I_Minus e1 e2)  ) = (I_Minus  (name_ExpInt(li,e1)) (name_ExpInt(li,e2)))
name_ExpInt(li,(I_Times e1 e2)  ) = (I_Times  (name_ExpInt(li,e1)) (name_ExpInt(li,e2)))
name_ExpInt(li,(I_Div   e1 e2)  ) = (I_Div    (name_ExpInt(li,e1)) (name_ExpInt(li,e2)))
name_ExpInt(li,(I_Mod   e1 e2)  ) = (I_Mod    (name_ExpInt(li,e1)) (name_ExpInt(li,e2)))


name_ExpBool(li,(B_Top)	     ) = (B_Top)
name_ExpBool(li,(B_Bottom)	 ) = (B_Bottom)
name_ExpBool(li,(B_Not b)	 ) = (B_Not (name_ExpBool(li,b) ))
name_ExpBool(li,(B_And b1 b2)) = (B_And (name_ExpBool(li,b1)) (name_ExpBool(li,b2)))
name_ExpBool(li,(B_Or  b1 b2)) = (B_Or  (name_ExpBool(li,b1)) (name_ExpBool(li,b2)))
name_ExpBool(li,(B_Eq  e1 e2)) = (B_Eq  (name_ExpInt(li,e1) ) (name_ExpInt(li,e2) ))
name_ExpBool(li,(B_Lt  e1 e2)) = (B_Lt  (name_ExpInt(li,e1) ) (name_ExpInt(li,e2) ))
name_ExpBool(li,(B_Le  e1 e2)) = (B_Le  (name_ExpInt(li,e1) ) (name_ExpInt(li,e2) ))
name_ExpBool(li,(B_Gt  e1 e2)) = (B_Gt  (name_ExpInt(li,e1) ) (name_ExpInt(li,e2) ))
name_ExpBool(li,(B_Ge  e1 e2)) = (B_Ge  (name_ExpInt(li,e1) ) (name_ExpInt(li,e2) ))




getExpInt(Number     i)	  = []
getExpInt(Variable i s)	  = [s]
getExpInt(Array	 i s e)   = [s]++(getExpInt e)
getExpInt(Function s l)   = [s]++(foldr (++) ([]) (map (\y->getExpInt(y)) l))
getExpInt(Neg  e) 	      = getExpInt(e)
getExpInt(I_Plus  e1 e2)  = getExpInt(e1) ++ getExpInt(e2)
getExpInt(I_Minus e1 e2)  = getExpInt(e1) ++ getExpInt(e2)
getExpInt(I_Times e1 e2)  = getExpInt(e1) ++ getExpInt(e2)
getExpInt(I_Div   e1 e2)  = getExpInt(e1) ++ getExpInt(e2)
getExpInt(I_Mod   e1 e2)  = getExpInt(e1) ++ getExpInt(e2)

learn_ExpInt(li,expInt) = aux li w@(getExpInt(expInt))
	where
		aux li [] = li
		aux li w@(h:t) = aux (learn(li,h)) t


getExpBool(B_Top)	     = []
getExpBool(B_Bottom)	 = []
getExpBool(B_Not b)	  	 = []
getExpBool(B_And b1 b2)  = []
getExpBool(B_Or  b1 b2)  = []
getExpBool(B_Eq  e1 e2)  = getExpInt(e1) ++ getExpInt(e2)
getExpBool(B_Lt  e1 e2)  = getExpInt(e1) ++ getExpInt(e2)
getExpBool(B_Le  e1 e2)  = getExpInt(e1) ++ getExpInt(e2)
getExpBool(B_Gt  e1 e2)  = getExpInt(e1) ++ getExpInt(e2)
getExpBool(B_Ge  e1 e2)  = getExpInt(e1) ++ getExpInt(e2)

learn_ExpBool(li,expBool) = aux li w@(getExpBool(expBool))
	where
		aux li [] = li
		aux li w@(h:t) = aux (learn(li,h)) t



--}

{-- Conditional Normal Form --}
normalise2::Command -> ExpBool -> BMC_Model
normalise2 p@(Assert			e	) b = BMC_IF (b) (Assert e)
normalise2 p@(Skip					) b = BMC_IF (b) (Skip)
normalise2 p@(Call			str		) b = BMC_IF (b) (Call	 str)
normalise2 p@(Assign 	i	str	e	) b = BMC_IF (b) (Assign i str e)
normalise2 p@(Composition 	c1 c2	) b = BMC_Cmp (normalise2 c1 b)  (normalise2 c2 b)
normalise2 p@(If 			e c1 c2	) b = BMC_Cmp (normalise2 c1 b1) (normalise2 c2 b2)
	where
		b1 = (B_And b e);
		b2 = (B_And b (B_Not e))


{-- [Test case] BMC technique --}


-- for each statment in Program of the form [if(c) v_{j+1}=e;]
--	[Set C] contains a formula of the form 
--		v_{j+1} = (c' ? e' : v_{j} )
--
-- tratar também os arrays

--	[Set P] contains a formula of the form (c′ ⊃ e′) for each statement in P at
--  location i of the form if(c) assert(e);,


--lol (Result id phi c psi vcs) = normalise (unwind 5 c) B_Top

--setFilter::BMC_Model->([],[]) {--(setP,setC)--}
setFilter::BMC_Model->([Assertion],[Assertion])
setFilter model = (setP , setC)
	where 	l = setFilter_0 model;
			setP = map (\(Left  x) -> x) (filter isLeft l);
			setC = map (\(Right x) -> x) (filter isRight l)

isRight(Right _) = True
isRight(Left  _) = False

isLeft(Right _) = False
isLeft(Left  _) = True

setFilter_0::BMC_Model->[Either Assertion Assertion]
setFilter_0(BMC_IF (c) p@(Assert		e	)) = [(Right (A_Then (A_Atom c) (A_Atom e)) 				)] -- precisa da normalização dos arrays por stores e outros...
setFilter_0(BMC_IF (c) p@(Skip				)) = [(Left  (A_Then (A_Atom c) (A_Atom B_Top)) 			)] --
setFilter_0(BMC_IF (c) p@(Call		str		)) = [(Left  (A_Then (A_Atom c) (A_Atom B_Top)) 			)] -- como se trata o skipp e o call??
setFilter_0(BMC_IF (c) p@(Assign i	str	e	)) = [(Left  --(A_And 
                                                                (A_Then (A_Atom c)           (A_Atom (B_Eq (Variable i str)                 (e)  ) ) ) 
-- jsp findings                                                                (A_Then (A_Atom (B_Not c))   (A_Atom (B_Eq (Variable i str) (Variable (i-1) str) ) ) )
                                                                --)
                                                                  )]
setFilter_0(BMC_Cmp bmcM1 bmcM2				 ) = (setFilter_0 bmcM1)++(setFilter_0 bmcM2)
--}
breaker c = putStrLn ("\n--------------["++c++"]----------\n")

-- Comand Line option managing system
data Flag = Version | Input String | Output String

options :: [OptDescr Flag]
options = [
    Option ['V'] ["version"] (NoArg Version)            "show version number",
    Option ['i'] ["input"]   (ReqArg Input "FILE")      "some option that requires a file argument",
    Option ['o'] ["output"]  (OptArg makeOutput "FILE") "some option with an optional file argument"
    ]

header = "Usage: main [OPTION...]"

makeOutput :: Maybe String -> Flag
makeOutput ms = Output ( fromMaybe "stdin" ms )



main::IO()
main = do{
    args        <- getArgs;
    case getOpt RequireOrder options args of
        (flags, [],      [])     -> print $ length flags
        (_,     nonOpts, [])     -> error $ "unrecognized arguments: " ++ unwords nonOpts
        (_,     _,       msgs)   -> error $ concat msgs ++ usageInfo header options
-- 	text        <- getContents;                                            -- get AST from stdin
--    text        <- readFile("./web/program.dsl");
-- 	procedures  <- return(map (\y->read y::Procedure) (lines text));       -- parse AST
-- 	putStrLn ":S"
 	
{--
 	writeFile ("program.tex") (pp_latex_2e_document [
	    (pp_latex_2e_section "Programa"                 (latex_pp_command 0 cmd)                                ),
	    (pp_latex_2e_section "unWinding"                (latex_pp_command 0 loopUn)                             ),
	    (pp_latex_2e_section "dynamicSAF"               (latex_pp_command 0 saf)                                ),
	    (pp_latex_2e_section "Conditional Normal Form"  (latex_pp_BMC_Model cnf)                                ),
	    (pp_latex_2e_section "Set P"                    (if((length setP)==0)then("$\\emptyset$")else("\\begin{itemize}"++(concat(map (\y->"\\item[] $"++(show y)++"$") setP))++"\\end{itemize}"))           ),
	    (pp_latex_2e_section "Set C"                    (if((length setC)==0)then("$\\emptyset$")else("\\begin{itemize}"++(concat(map (\y->"\\item[] $"++(show y)++"$") setC))++"\\end{itemize}"))           ),
	    (pp_latex_2e_section "SMT-LIB2"                 ("\\begin{verbatim}"++( smt(setP,setC) )++"\\end{verbatim}")       )
	    ]);
	
	
	writeFile ("program.smt") ( smt(setP,setC) );
--} 	
-- 	putStrLn (logicLayer args procedures)
}
logicLayer [] _ = "[ERROR]: No Arguments" 
logicLayer args procedures = case(head args)of
                        "tex"   -> returnTEX procedures
                        "smt"   -> returnSMT procedures
                        _       -> "[ERROR]: Wrong Arguments"
                            
returnTEX procedures =  let (cmd, loopUn, saf, cnf, setP, setC) = bmc 2 procedures;
                        in  (pp_latex_2e_document [
                    	    (pp_latex_2e_section "Programa"                 (latex_pp_command 0 cmd)                                ),
                    	    (pp_latex_2e_section "unWinding"                (latex_pp_command 0 loopUn)                             ),
                    	    (pp_latex_2e_section "dynamicSAF"               (latex_pp_command 0 saf)                                ),
                    	    (pp_latex_2e_section "Conditional Normal Form"  (latex_pp_BMC_Model cnf)                                ),
                    	    (pp_latex_2e_section "Set P"                    (if((length setP)==0)then("$\\emptyset$")else("\\begin{itemize}"++(concat(map (\y->"\\item[] $"++(show y)++"$") setP))++"\\end{itemize}"))           ),
                    	    (pp_latex_2e_section "Set C"                    (if((length setC)==0)then("$\\emptyset$")else("\\begin{itemize}"++(concat(map (\y->"\\item[] $"++(show y)++"$") setC))++"\\end{itemize}"))           ),
                    	    ("\\pagebreak\n"),
                    	    (pp_latex_2e_section "SMT-LIB2"                 ("\\begin{verbatim}"++( smt(setP,setC) )++"\\end{verbatim}")       )
                    	    ])
                    	    
returnSMT procedures =  let (cmd, loopUn, saf, cnf, setP, setC) = bmc 2 procedures;
                        in smt(setP,setC)


{--

writeFileUTF8 file text = withFile file WriteMode $ \handle -> do
        hSetEncoding handle utf8
        hPutStr handle text

readFileUTF8 file = do
    handle <- openFile file ReadMode
    hSetEncoding handle utf8
    hGetContents handle
--}




--    cmd <- return(e10);
{--	putStrLn (show cmd) --}{-- DEBUGG PARSER --}
	-- unwind2::Int->Command->Command
	-- saf2::Command->Command
	-- normalise2::Command -> ExpBool -> BMC_Model
{--
	breaker("PROGRAM");
	putStrLn (show cmd);
	breaker("unWinding");
	r_unwound <-return(unwind2 5 cmd);
	putStrLn (show r_unwound);
	breaker("SAF");
	(tbl,r_saf) <- return(safCommand [] r_unwound);
	putStrLn (show r_saf);
	breaker("Table");
	putStrLn (show tbl);
	breaker("CNF");
	r_cnf <- return(normalise2 r_saf B_Top);
	putStrLn (show r_cnf);
	breaker("FILTER");
	(setC,setP) <- return(setFilter r_cnf);
	breaker("setC");
	setCstr <- return(foldr (++) [] (map (\y->"\\item[$>$] $"++(show y)++"$\\\\\n") setC));
	putStrLn setCstr;
	breaker("setP");
	setPstr <- return(foldr (++) [] (map (\y->"\\item[$>$] $"++(show y)++"$\\\\\n") setP));
	putStrLn setPstr;
	
	
--	writeFile ("../smt/output.smt") (pp_latex_2e_document setCstr);
	
	
	
	putStrLn ""
-- 	writeFile ("engine_contents.log") (show cmd);                              -- prettyprint to log
--	file@(File la ld lf lr le lp) <- return(read text::File);       -- parse AST
--	[Result]
--	vcs_list <- return(vcGen_manager file );                        -- compute vcGen for each procedure
	
--	mapM_ (\(Result id phi c psi vcs)->writeFile ("debugger_"++id++".log") (show(lol(Result id phi c psi vcs)))) vcs_list;
	
--	mapM_ (\(Result id phi c psi vcs)->writeFile ("smt/op1_smt_v2_"++id++".smt2") (pp_smt_lib_v2 (id,la,ld,lf) (phi,c,psi) vcs)) vcs_list; -- prettyprint to SMT-LIB v2.0
--	mapM_ (\(Result id phi c psi vcs)->writeFile ("tex/op1_latex2e_"++id++".tex") (pp_latex_2e   (id,la,ld,lf) (phi,c,psi) vcs)) vcs_list; -- prettyprint to LaTeX2e
--	writeFile ("engine_contents.log") (show file);                              -- prettyprint to log
}
--}





{-- //SMT_LIB v2.0 --}


pp_smt_document = nl("(set-option :print-success true)")


copyPaste list = case(getProcedure "main" list)of
                    Nothing             -> error "[ERROR]: procedure [main] NOT found"
                    Just(Proc str cmd)  -> substitute list cmd
                    



bmc::Int->[Procedure]->(Command,Command,Command,BMC_Model,[Assertion],[Assertion])
bmc lim list = let  cmd     = (copyPaste list)
                    loopUn  = (unwind2 lim cmd)
                    saf     = (dynamicSAF loopUn)
                    cnf     = (normalise2 saf (B_Top))
                    (setP,setC) = (setFilter cnf)
                in (cmd, loopUn, saf, cnf, setP, setC)





{--


/*
 *
 *
 *
 *
 */

--}










pp_latex_2e_section::String->String->String

pp_latex_2e_section section body =  ("")
			++ nl("\\section{"++section++"}")
			++ nl("\\noindent")
			++ body
--			++ nl("\\pagebreak")

{-- //LATEX --}

pp_latex_2e_document::[String]->String
pp_latex_2e_document l = ("")
            ++ nl("%& -output-directory=.web/program.pdf -aux-directory=C:/.web/lol")
            ++ nl("\\documentclass[6pt,a4paper,onecolumn,oneside]{article}")
			++ pp_latex_2e_packages
			++ nl("\\begin{document}")
			++ (concat l)
			++ nl("\\end{document}")
--
pp_latex_2e_title::Int->String->String
pp_latex_2e_title 1 id	= ("\\noindent")
			++ nl_block("small","Mestrado em Matemática e Computação")
			++ nl_block("small","Programação Certificada - Ano lectivo de 2010/2011")
			++ nl_block("small","Projecto de Programação Certificada")
			++ nl_block("small","\\today")
			++ nl("\\begin{center}")
			++ nl_block("large","Lógica de Hoare para uma linguagem imperativa simples")
			++ nl_block("large","Prova de correcção e implementação de um VCGen")
			++ nl("\\end{center}\\")
			++ nl_block("","")
			++ nl_block("footnotesize","Realizado por:")
			++ nl_block("scriptsize","{\\color{rltwhite} ,}\\hspace{2cm} - Isabel Maria Ventura Santos - pg17227@alunos.uminho.pt")
			++ nl_block("scriptsize","{\\color{rltwhite} ,}\\hspace{2cm} - José João Peixoto Pereira   - pg17312@alunos.uminho.pt")
			++ nl_block("","")
			++ nl_block("footnotesize","Professores Orientadores:")
			++ nl_block("scriptsize","{\\color{rltwhite} ,}\\hspace{2cm} - Jorge Sousa Pinto           - Departamento de Informática")
			++ nl_block("scriptsize","{\\color{rltwhite} ,}\\hspace{2cm} - Luís Filipe Ribeiro Pinto   - Departamento de Matemática")
			++ nl_block("","")
			++ nl_block("footnotesize","Em conformidade com o standard \\LaTeXe")
			++ nl_block("scriptsize","{\\color{rltwhite} ,}\\hspace{2cm} - \\url{http://latex.computersci.org/Reference/Reference}")
--			++ nl_block("","")
--			++ nl_block("","")

pp_latex_2e_title 0 id	= ("")
			++ nl("\\title{Lógica de Hoare para uma linguagem imperativa simples}")
			++ nl("\\date{\\today}")
			++ nl("\\author{Isabel Maria Ventura Santos, pg17227@alunos.uminho.pt")
			++ nl("\\and José João Peixoto Pereira, pg17312@alunos.uminho.pt}")
			++ nl("\\maketitle")
			++ nl("\\vspace{.5cm}")
			++ nl("{\\Huge "++id++"}")
--
pp_latex_2e_packages::String
pp_latex_2e_packages 	=  ("")
			++ nl("\\usepackage[utf8]{inputenc}")
			++ nl("\\usepackage[portuguese]{babel}")
			++ nl("\\usepackage{amsmath}")
--			++ nl("\\usepackage[landscape]{geometry}")
			++ nl("\\usepackage[pdftex, colorlinks=true,")
			++ nl("    urlcolor=rltblue,")
			++ nl("    filecolor=rltgreen,")
			++ nl("    linkcolor=rltred,")
			++ nl("    pdftitle={Lógica de Hoare para uma linguagem imperativa simples},")
			++ nl("    pdfauthor={pg17227 - Isabel Maria Ventura Santos - pg17312 - José João Peixoto Pereira - Rui Miguel Silva Couto - Nuno Filipe Solinho Azevedo - Pedro Miguel Duarte Mendonca - pg17207 José Miguel Gomes Loureiro},")
			++ nl("    pdfsubject={Prova de correccão e implementacão de um VCGen},")
			++ nl("    pdfkeywords={Lógica de Hoare, VCGen},")
			++ nl("    pagebackref,")
			++ nl("    pdfpagemode=None,")
			++ nl("    bookmarksopen=true]{hyperref}")
			++ nl("\\usepackage{color}")
			++ nl("\\definecolor{rltred}{rgb}{0.75,0,0}")
			++ nl("\\definecolor{rltgreen}{rgb}{0,0.5,0}")
			++ nl("\\definecolor{rltblue}{rgb}{0,0,0.75}")
			++ nl("\\definecolor{rltwhite}{rgb}{1,1,1}")
			++ nl("")
--			++ nl("\\usepackage{tex_program}")
			++ nl("")
			++ nl("\\linespread{1.1}")
--



latex_pp_BMC_Model::BMC_Model->String
latex_pp_BMC_Model(BMC_Cmp  m1 m2)  = (latex_pp_BMC_Model m1)++"\\\\\n"++(latex_pp_BMC_Model m2)
latex_pp_BMC_Model(BMC_IF   b  c )  = " \\textbf{if}($"++(show b)++"$)\\{"
        ++(latex_pp_command 0 c)
        ++"\\} "


latex_pp_command::Int->Command->String
latex_pp_command n (Skip)			    = (latex_pp_tab n)++" \\textbf{skip} "
latex_pp_command n (Call str)	        = (latex_pp_tab n)++" \\textbf{call}($"++(str)++"$) "
latex_pp_command n (Assert e)		    = (latex_pp_tab n)++" \\textbf{assert}($"++(show e)++"$) "
latex_pp_command n (Assign i v e)		= (latex_pp_tab n)++" $ "++(v)++"_{"++(show i)++"} $  := $"++(show e)++"$ "
latex_pp_command n (Composition c1 c2)	= (latex_pp_command n c1)++";\\\\\n"++(latex_pp_command n c2)
latex_pp_command n (If b c1 c2)		    = (latex_pp_tab n)++" \\textbf{if}($"++(show b)++"$)\\{\\\\\n"
        ++(latex_pp_command (n+1) c1) ++ "\\\\\n"
        ++(latex_pp_tab n)++"\\}\\textbf{else}\\{\\\\\n"
        ++(latex_pp_command (n+1) c2) ++ "\\\\\n"
        ++(latex_pp_tab n)++"\\}\n "
latex_pp_command n (While b i c)		= (latex_pp_tab n)++" \\textbf{while}($"++(show b)++"$) do \\{$"++(show i)++"$\\}\\{\\\\\n"
        ++(latex_pp_command (n+1) c) ++ "\\\\\n"
        ++(latex_pp_tab n)++"\\}\n "
    



latex_pp_tab 0 = ""
latex_pp_tab n = "{\\color{rltwhite}$->$}"++(latex_pp_tab (n-1))