/*
 * Mestrado em Matemática e Computação
 * Programação Certificada
 *      - Ano lectivo de 2010/2011
 * Projecto de Programação Certificada
 * 
 * 
 * Lógica de Hoare para uma linguagem imperativa simples
 *      - Prova de correcção e implementação de um VCGen
 * 
 * 
 * Realizado por:
 *      - Isabel Maria Ventura Santos - pg17227@alunos.uminho.pt
 *      - José João Peixoto Pereira   - pg17312@alunos.uminho.pt
 * 
 * 
 * Professores Orientadores:
 *      - Jorge Sousa Pinto           - jsp@di.uminho.pt
 *      - Luís Filipe Ribeiro Pinto   - luis@math.uminho.pt
 */
 
 
/*
 *  Específicação LEX
 */

%{ /* @header */
    #include <stdio.h>          // input/output
    #include "y.tab.h"          // gramática e programa referente a esta específicação
    extern int err_line;        // linha do ficheiro onde se localiza o lookhead
    extern int err_column;      // coluna do ficheiro onde se localiza o lookhead
    int v=0;                    // verbosidade (for debugging purposes)
%}
/* Expressões regulares */

/* palavras reservadas */

/* extenção: meta-informação */
/*
META_PREDICATE	"@predicate"
META_FUNCTION	"@function"
META_AXIOM	    "@axiom"
META_REQUIRES	"@requires"
META_ENSURES	"@ensures"
*/



/*doc:begin:lex_Command*/
/* command expression tokens */
SKIP        "skip"
ASSERT      "assert"
ASSIGN      ":="
COMPOSITION ";"
IF          "if"
ELSE        "else"
WHILE       "while"
DO          "do"
CALL        "call"
PROC        "proc"
/*doc:end:lex_Command*/

/*doc:begin:lex_Other*/
/* non reservaded words (identifiers, numbers, etc.)*/
LETTER      [a-zA-Z]
DIGIT       [0-9]

NUMBER      {DIGIT}+
VARIABLE    [a-zA-Z_][a-zA-Z_0-9.]*

SOMETHING   [a-zA-Z0-9(){}+*\-]*
/* white spaces */
WSPACES     [ \t\r\f\n]
/*doc:end:lex_Other*/




/*doc:begin:lex_ExpInt*/
/* integer expression tokens */
I_Plus      "+"
I_Minus     "-"
I_Times     "*"
I_Div       "div"
I_Mod       "mod"
/*doc:end:lex_ExpInt*/


/*doc:begin:lex:ExpBool*/
/* boolean expression tokens */
B_Top       "true"
B_Bottom    "false"
B_Not       "!"
B_And       "&"
B_Or        "|"
B_Then      "->"
B_Eq        "=="
B_Neq       "!="
B_Lt        "<"
B_Le        "<="
B_Gt        ">"
B_Ge        ">="
/*doc:end:lex_ExpBool*/
/* asserções */
/*
A_And		"&&"
A_Or		"||"
A_Then		"->"
A_Iff		"<->"
FORALL		"\\forall"
EXISTS		"\\exists"
*/

/*
{META_PREDICATE}    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(META_PREDICATE);}
{META_FUNCTION} 	{err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(META_FUNCTION);}
{META_AXIOM}		{err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(META_AXIOM);}
{META_REQUIRES}		{err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(META_REQUIRES);}
{META_ENSURES}		{err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(META_ENSURES);}



*/

/*
{A_And}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(A_And);}
{A_Or}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(A_Or);}
{A_Then}		    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(A_Then);}
{A_Iff}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(A_Iff);}
{FORALL}		    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(FORALL);}
{EXISTS}		    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(EXISTS);}
*/


%%/* REGRA          {localização do lookhead; debugging; registro do token; retorno do token}*/


{PROC}  		    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(PROC);}
{CALL}  		    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(CALL);}
{ASSERT}  		    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(ASSERT);}

{I_Plus}		    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(I_Plus);}
{I_Minus}		    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(I_Minus);}
{I_Times}		    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(I_Times);}
{I_Div}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(I_Div);}
{I_Mod}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(I_Mod);}

{B_Top}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(B_Top);}
{B_Bottom}		    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(B_Bottom);}
{B_Not}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(B_Not);}
{B_And}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(B_And);}
{B_Or}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(B_Or);}
{B_Then}			{err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(B_Then);}
{B_Eq}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(B_Eq);}
{B_Neq}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(B_Neq);}
{B_Lt}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(B_Lt);}
{B_Le}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(B_Le);}
{B_Gt}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(B_Gt);}
{B_Ge}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(B_Ge);}

{SKIP}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(SKIP);}
{ASSIGN}		    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(ASSIGN);}
{COMPOSITION}		{err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(COMPOSITION);}
{IF}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(IF);}
{ELSE}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(ELSE);}
{WHILE}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(WHILE);}
{DO}			    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(DO);}

{VARIABLE}          {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(VARIABLE);}
{NUMBER}		    {err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(NUMBER);}

[(){}\[\]=,:]		{err_column+=yyleng;if(v)printf(">%s\n",yytext);yylval.v_str = strdup(yytext); return(yytext[0]);}
.                   {err_column+=yyleng;}
\n                  {err_line++;err_column=0;}

%%